function [W, funcVal, best_param] = Least_Trace_Malsar( Xtr_malsar, Ytr_malsar, best_param, opts, verbose )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

    if nargin < 5
        verbose = false;
    end

    % the function used for evaluation.
    eval_func_str = 'my_eval_MTL_mse2';
    higher_better = false;  % mse is lower the better.

    % cross validation fold
    cv_fold = 5;

    % optimization options
    if isempty(opts)
        opts = [];
        opts.init = 0;
        opts.tol = 0.0001;
        opts.maxIter = 1000;
    end
    
    param_range = 1:1:30; % GDSC data, NCI Data
    %param_range = 1:0.5:20;
    %param_range = [1e-4 1e-2 1e3 1e4];

    if verbose
        fprintf('Perform model selection via cross validation for Least_trace: \n')
    end
    perform_mat = [];
    if isempty(best_param)
        [ best_param, perform_mat] = CrossValidation1Param...
            ( Xtr_malsar, Ytr_malsar, 'Least_Trace', opts, param_range, cv_fold, eval_func_str, higher_better);
    end
    
    
    if verbose
        disp(perform_mat) % show the performance for each parameter.
        fprintf('Best param : %d\n',best_param);
    end

    % build model using the optimal parameter 
    [W,funcVal] = Least_Trace(Xtr_malsar, Ytr_malsar, best_param, opts);
    if verbose
        fprintf('Non-zero weights : %d\n',nnz(W));
    end
end

