function model = kMTraceTrain( X, Y, p)
%KERNELTRACE Summary of this function goes here
%   Detailed explanation goes here

if nargin < 3
   p = -1
end

si = mean(pdist(X))/sqrt(2);
gamma = 1/(2*si^2);
K = rbf(X,gamma);
mu_xtr = classreg.learning.internal.wnanmean(K, ones(1,size(K,1)));
K = bsxfun(@minus,K,mu_xtr);
mu_ytr = classreg.learning.internal.wnanmean(Y, ones(1,size(Y,1)));
centeredY = bsxfun(@minus,Y,mu_ytr);
[Xtr_malsar, Ytr_malsar] = convert2MalsarFormat(K, centeredY);

if p == -1
  model.W = Least_Trace_Malsar(Xtr_malsar, Ytr_malsar,[],[]);
else
  model.W = Least_Trace_Malsar(Xtr_malsar, Ytr_malsar,p,[]);
end
model.mu_xtr = mu_xtr;
model.mu_ytr = mu_ytr;
model.gamma = gamma;
model.X = X;
model.desc = '';

